//Mon-Chaio Lo
//CSE 142 AA Winter 99
//Student #: 9825450

#include "gp142.h"
#include <math.h>
#include <time.h>

#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

#define FILL 0

#define STATUS_ADD_OBJECT 1
#define STATUS_SELECTED 2

#define SHAPE_HEART 0
#define SHAPE_STAR 1
#define SHAPE_CIRCLE 2
#define SHAPE_SUN 3

#define TRUE 1
#define FALSE 0

#define MAX_BUTTONS 4
#define BUTTON_HEIGHT 35
#define BUTTON_WIDTH 100

#define OBJECT_SHAPE 0
#define OBJECT_MESSAGE 1

#define SELECTED_COLOR RED

#define CLICK_BUTTON 1	
#define CLICK_CARD 2	
#define CLICK_OUTSIDE 3 

#define MAX_SHAPES 4

#define MAX_MESSAGES 5
#define MESSAGE_1 0
#define MESSAGE_2 1
#define MESSAGE_3 2
#define MESSAGE_4 3
#define MESSAGE_5 4

#define MAX_OBJECTS 20

#define OFFSET 20

typedef struct
{
	int object_type,
		object_num,
		color;
	GP142_point origin,
		LL_point,
		UR_point;
} object_t;

void DrawBlankScreen (int color);
void DrawCard (int background_color, int status, int object_count, object_t draw_obj[MAX_OBJECTS]);
void DrawShape(int shape_type, int color, GP142_point xy);
void DrawHeart (GP142_point xy, int color);
void DrawStar (GP142_point xy, int color);
void DrawSun (GP142_point xy, int color);
void DrawCircle (GP142_point xy, int color);
void DrawButtons(int last_button);
void AddObject(GP142_point xy, int *status, int *object_count, object_t obj[MAX_OBJECTS], int *obj_select_num);
void HandleButton(GP142_point xy, int *background_color, int *status, int object_count,
				  object_t objct[MAX_OBJECTS], int select_num, int *button);
void HandleMouseClick(GP142_point mouse_xy, int *background_color, int *status, int *object_count,
					  object_t obj[MAX_OBJECTS], int *select_num, int *button);
int  ClassifyMouseClick(GP142_point mouse_xy);
void WriteMessage(int message_type, int color, GP142_point xy);
void DrawIntroScreen();

int main(void)
{
	int background_color = YELLOW,
		status = STATUS_ADD_OBJECT,
		object_count = 0,
		quit = FALSE,
		last_button = -1,
		event,
		obj_select_num = -1;
	char key_hit;
	GP142_point mouse_xy;
	time_t t;
	
	object_t objects[MAX_OBJECTS];
	
	srand(time(&t));
	
	GP142_open();
	GP142_show_text(0);
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);
	
	DrawIntroScreen();
	
	while (!quit)
	{
		DrawBlankScreen(WHITE);
		DrawCard(background_color, status, object_count, objects);
		DrawButtons(last_button);
		
		event = GP142_await_event(&mouse_xy.x, &mouse_xy.y, &key_hit);
		
		switch (event)
		{
		case GP142_QUIT:
			quit = TRUE;
			break;
		case GP142_KBD:
			break;
		case GP142_MOUSE:
			HandleMouseClick(mouse_xy, &background_color, &status, &object_count, objects,
				&obj_select_num, &last_button); 		
			break;
		case GP142_PERIODIC:
			break;
		default:
			break;
		}
	}	
	
	GP142_close();
	
	return(0);
}

void DrawBlankScreen(int color)
{
	int font_size = 14;
	
	GP142_rectangleXY(color, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, GP142_YMAX, FILL);
}

void DrawCard(int background_color, int status, int object_count, object_t draw_obj[MAX_OBJECTS])
{
	int font_size = 14,
		header_font_size = 28,
		i = 0;
	
	GP142_printfXY(PURPLE, PAGE_LLX - 30, PAGE_LLY + PAGE_HEIGHT + 10, header_font_size, 
		"VALENTINE CARD CREATOR v1.0");
	GP142_rectangleXY(background_color, PAGE_LLX, PAGE_LLY, PAGE_LLX + PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT, FILL);
	
	if (object_count > 0)
	{
		for (i = 0; i < object_count; ++i)
		{
			if (draw_obj[i].object_type == OBJECT_SHAPE)
			{
				DrawShape(draw_obj[i].object_num,
					draw_obj[i].color,
					draw_obj[i].origin);
			}
			if (draw_obj[i].object_type == OBJECT_MESSAGE)
			{
				WriteMessage(draw_obj[i].object_num,
					draw_obj[i].color,
					draw_obj[i].origin);
			}
		}
	}
	
	switch (status)
	{
	case STATUS_ADD_OBJECT:
		GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-40, font_size, "Click on the card to add an object");
		GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-60, font_size, "Click on a shape to select");
		GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-80, font_size,
			"Click on the first letter of a message to select");
		break;
	case STATUS_SELECTED:
		GP142_printfXY(RED, PAGE_LLX, PAGE_LLY - 40, font_size, "Object selected. Click buttons to modify");
		GP142_printfXY(RED, PAGE_LLX, PAGE_LLY - 60, font_size, "Click outside of card to deselect object");
		break;
	default:
		GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-40, font_size, "Status error -- notify programmer");
		break;
	}	
}

void DrawShape(int shape_type, int color, GP142_point xy)
{
	switch (shape_type)
	{
	case SHAPE_HEART:
		DrawHeart(xy, color);
		break;
	case SHAPE_STAR:
		DrawStar(xy, color);
		break;
	case SHAPE_CIRCLE:
		DrawCircle(xy, color);
		break;
	case SHAPE_SUN:
		DrawSun(xy, color);
		break;
	default:
		break;
	}
}

#define HEART_WIDTH 35
void DrawHeart(GP142_point xy, int color)
{
	int h = (HEART_WIDTH/2) + (rand () %4);
	
	GP142_circleXY (color, xy.x - h + 5, xy.y, h);
	GP142_circleXY (color, xy.x + h - 5, xy.y, h);
	GP142_triangleXY (color, xy.x- h*2 +5, xy.y-5, xy.x + h*2 -5, xy.y-5, xy.x, xy.y - h*2 -5, FILL);
}

#define CIRCLE_WIDTH 40
void DrawCircle(GP142_point xy, int color)
{
	int h = (CIRCLE_WIDTH / 2) + (rand() % 4);
	GP142_circleXY(color, xy.x, xy.y, h);
}

#define SUN_WIDTH 20
void DrawSun(GP142_point xy, int color)
{
	int h = (SUN_WIDTH / 2) + (rand() % 4);
	GP142_circleXY(color, xy.x, xy.y, h);
	DrawStar(xy, color);
}

#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
void DrawStar(GP142_point xy, int color)
{
	int sp,
		x1,
		y1;
	double angle;
	
	sp = STARPOINTS + (rand() %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2 * PI) / sp)
	{
		x1 = (int)(cos(angle) * STARRADIUS);
		y1 = (int)(sin(angle) * STARRADIUS);
		GP142_lineXY(color, xy.x+x1, xy.y+y1, xy.x-x1, xy.y-y1, 1);
	}
}

void DrawButtons(int last_button)
{
	char b_labels [MAX_BUTTONS][25] = {"Background color", "Next object", "Next color", "Change object"};
	
	int i,
		text_offset = -GP142_XMAX + 6,
		font_size = 12,
		y,
		label_y;
	
	for(i = 0; i < MAX_BUTTONS; ++i)
	{
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK, -GP142_XMAX + 4, y - 2, -GP142_XMAX + BUTTON_WIDTH, y - BUTTON_HEIGHT - 2, 1);
		
		GP142_lineXY(BLACK, -GP142_XMAX + 7, y - BUTTON_HEIGHT - 2, -GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, 3);
		
		GP142_lineXY(BLACK, -GP142_XMAX + BUTTON_WIDTH, y - 4, -GP142_XMAX + BUTTON_WIDTH, 
			y - BUTTON_HEIGHT - 2, 3);
		
		label_y = y - BUTTON_HEIGHT / 2;
		
		if (i == last_button)
			GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size, b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}	
}

int ClassifyMouseClick(GP142_point mouse_xy)
{
	if ((mouse_xy.x < -GP142_XMAX + BUTTON_WIDTH) &&
		(mouse_xy.y < GP142_YMAX) &&
		(mouse_xy.y > (GP142_YMAX - MAX_BUTTONS*BUTTON_HEIGHT)))
		return CLICK_BUTTON;
	else if ((mouse_xy.x >= PAGE_LLX) &&
		(mouse_xy.x < PAGE_LLX + PAGE_WIDTH) &&
		(mouse_xy.y >= PAGE_LLY) &&
		(mouse_xy.y < PAGE_LLY + PAGE_HEIGHT))
		return CLICK_CARD;
	else
		return CLICK_OUTSIDE;
}

void HandleMouseClick(GP142_point mouse_xy, int *background_color, int *status, int *object_count,
					  object_t obj[MAX_OBJECTS], int *select_num, int *button)
{
	int mouse_click,
		i;
	
	mouse_click = ClassifyMouseClick(mouse_xy);
	
	if (mouse_click == CLICK_BUTTON)
	{
		HandleButton(mouse_xy, background_color, status, *object_count, obj, *select_num, button);
		return;
	}
	if (mouse_click == CLICK_CARD)
	{
		if (*status == STATUS_SELECTED)
		{
			obj[*select_num].origin.x = mouse_xy.x;
			obj[*select_num].origin.y = mouse_xy.y;
			obj[*select_num].LL_point.x = obj[*select_num].origin.x - OFFSET;
			obj[*select_num].LL_point.y = obj[*select_num].origin.y - OFFSET;
			obj[*select_num].UR_point.x = obj[*select_num].origin.x + OFFSET;
			obj[*select_num].UR_point.y = obj[*select_num].origin.y + OFFSET;
			return;
		}
		
		if ((*object_count >= 0) && (*object_count <= MAX_OBJECTS))
		{
			if (*object_count > 0)
			{
				for (i=0; i < *object_count; ++i)
				{
					if ((mouse_xy.x > obj[i].LL_point.x) &&
						(mouse_xy.x < obj[i].UR_point.x) &&
						(mouse_xy.y > obj[i].LL_point.y) &&
						(mouse_xy.y < obj[i].UR_point.y))
					{
						*status = STATUS_SELECTED;
						*select_num = i;
						return;
					}
				}
			}
			
			AddObject(mouse_xy, status, object_count, obj, select_num);
			return;
		}
	}
	
	*status = STATUS_ADD_OBJECT;
	*select_num = -1;
}

void HandleButton(GP142_point xy, int *background_color, int *status, int object_count,
				  object_t objct[MAX_OBJECTS], int select_num, int *button)
{
	int buttonNum = 0;
	
	if (xy.x > -GP142_XMAX + BUTTON_WIDTH)
		return ;
	
	buttonNum = (GP142_YMAX - xy.y) / BUTTON_HEIGHT;
	*button = buttonNum;
	
	switch(buttonNum)
	{
	case 0:
		*background_color = (*background_color + 1) % MAX_COLORS;
		break;
	case 1:
		if ((object_count > 0) && (*status == STATUS_SELECTED))
		{
			if (objct[select_num].object_type == OBJECT_SHAPE)
				objct[select_num].object_num = (objct[select_num].object_num + 1) % MAX_SHAPES;
			if ((objct[select_num].object_type == OBJECT_MESSAGE))
				objct[select_num].object_num = (objct[select_num].object_num + 1) % MAX_MESSAGES;
		}
		break;
	case 2:
		if ((object_count > 0) && (*status == STATUS_SELECTED))
		{
			objct[select_num].color = (objct[select_num].color + 1) % MAX_COLORS;
		}
		break;
	case 3:
		if ((object_count > 0) && (*status == STATUS_SELECTED))
		{
			if (objct[select_num].object_type == OBJECT_SHAPE)
			{
				objct[select_num].object_type = OBJECT_MESSAGE;
				objct[select_num].object_num %= MAX_MESSAGES;
				return;
			}
			if (objct[select_num].object_type == OBJECT_MESSAGE)
			{
				objct[select_num].object_type = OBJECT_SHAPE;
				objct[select_num].object_num %= MAX_SHAPES;
				return;
			}
		}
		break;
	default:
		*status = 999;
		break;
	}
}

void AddObject(GP142_point xy, int *status, int *object_count, object_t obj[MAX_OBJECTS], int *obj_select_num)
{
	if (*object_count < MAX_OBJECTS)
	{
		*status = STATUS_SELECTED;
		*obj_select_num = *object_count;
		obj[*object_count].object_type = OBJECT_SHAPE;
		obj[*object_count].object_num = SHAPE_HEART;
		obj[*object_count].color = BLACK;
		obj[*object_count].origin.x = xy.x;
		obj[*object_count].origin.y = xy.y;
		obj[*object_count].LL_point.x = obj[*object_count].origin.x - OFFSET;
		obj[*object_count].LL_point.y = obj[*object_count].origin.y - OFFSET;
		obj[*object_count].UR_point.x = obj[*object_count].origin.x + OFFSET;
		obj[*object_count].UR_point.y = obj[*object_count].origin.y + OFFSET;
		*object_count += 1;
	}
}

#define FONT_SIZE 20
void WriteMessage(int message_type, int color, GP142_point xy)
{
	int change = FONT_SIZE + (rand() % 5);
	
	switch (message_type)
	{
	case MESSAGE_1:
		GP142_printfP(color, xy, change, "BE MY VALENTINE");
		break;
	case MESSAGE_2:
		GP142_printfP(color, xy, change, "I LOVE YOU");
		break;
	case MESSAGE_3:
		GP142_printfP(color, xy, change, "KISS ME");
		break;
	case MESSAGE_4:
		GP142_printfP(color, xy, change, "LOVE IS IN THE AIR");
		break;
	case MESSAGE_5:
		GP142_printfP(color, xy, change, "PLEASE BE MINE");
		break;
	default:
		break;
	}
}

void DrawIntroScreen()
{
	int quit = FALSE,
		event,
		box_color = BLACK;
	GP142_point mouse;
	char key_hit;
	
	DrawBlankScreen(BLACK);
	
	GP142_printfXY(RED, -GP142_XMAX + 15, GP142_YMAX - 130, 36, "VALENTINE CARD CREATOR v1.0");
	GP142_printfXY(GREEN, -GP142_XMAX + 150, GP142_YMAX - 160, 28, "Coded by Mon-Chaio Lo");
	GP142_printfXY(WHITE, -GP142_XMAX + 165, GP142_YMAX - 250, 24, "CSE 142 AA Winter 1999");
	GP142_printfXY(WHITE, -GP142_XMAX + 165, GP142_YMAX - 290, 24, "University of Washington");
	GP142_printfXY(RED, -GP142_XMAX + 85, GP142_YMAX - 430, 28, "PRESS ANY KEY TO CONTINUE");
	
	while (!quit)
	{
		GP142_rectangleXY(box_color, -GP142_XMAX + 100, GP142_YMAX - 350, GP142_XMAX - 100, GP142_YMAX - 180, 3);
		event = GP142_await_event(&mouse.x, &mouse.y, &key_hit);
		
		switch (event)
		{
		case GP142_QUIT:
			quit = TRUE;
			break;
		case GP142_KBD:
			quit = TRUE;
			break;
		case GP142_MOUSE:
			quit = TRUE;	
			break;
		case GP142_PERIODIC:
			break;
		default:
			break;
		}
		
		box_color = (box_color + 1) % MAX_COLORS;
	}
}